
local Widget = LIBTD('Widget')
if not Widget or Widget('CheckButton') then return end

local CreateFrame = CreateFrame

local CheckButton = Widget:NewModule('CheckButton', CreateFrame('CheckButton'))
Widget:CopyFunctions(CheckButton)

function CheckButton:New(parent, db, ...)
    local check = self:Bind(CreateFrame('CheckButton', nil, parent))
    
	check:SetNormalTexture([[Interface\Buttons\UI-CheckBox-Up]])
	check:SetPushedTexture([[Interface\Buttons\UI-CheckBox-Down]])
	check:SetHighlightTexture([[Interface\Buttons\UI-CheckBox-Highlight]])
	check:SetCheckedTexture([[Interface\Buttons\UI-CheckBox-Check]])
	check:SetHitRectInsets(0, -100, 0, 0)
	check:SetSize(26, 26)
    check:SetFontString(check:CreateLabel('LEFT', 'RIGHT', 2, 0))
    
    check:SetScript('OnClick', self.OnClick)
    
    check:SetDBAndKeys(db, ...)
    
    return check
end

function CheckButton:Update()
    self:SetChecked(self:GetDBValue())
end

function CheckButton:GetPositionArgs()
    return 40, 0, 0 -- height, y, lx, rx
end

function CheckButton:OnClick()
    self:SaveDBValue(self:GetChecked() and true or nil)
end
CheckButton.SetLabelText = CheckButton.SetText

function CheckButton:GetWidgetType()
    return 'CheckButton'
end
