﻿
local Widget = LIBTD('Widget')
if not Widget or not Widget('Listbox') or Widget('FontPicker') then return end

local Media = Widget.Media
local Listbox = Widget('Listbox')
local FontPicker = Widget:NewModule('FontPicker', Listbox:New()) FontPicker:Hide()

local Update = FontPicker.Update

function FontPicker:New(parent, db, ...)
    local fontpicker = self:Bind(Listbox:New(parent))
    
    fontpicker:EnableSelect(true)
    fontpicker:SetExtraButton()
    fontpicker:SetHeight(140)
    fontpicker:SetList(Media.Fonts)
    
    fontpicker:SetDBAndKeys(db, ...)
    
    return fontpicker
end

function FontPicker:OnSelectChanged(index)
    self:SaveDBValue(self:GetSelectedValue())
end

function FontPicker:Update()
    Update(self)
    
    local font = self:GetDBValue()
    for i, item in ipairs(self:GetList()) do
        if font == self:GetItemValue(item) then
            self:SetChecked(i)
            return
        end
    end
end

function FontPicker:GetShowText()
    return '      |cffffffffABCDEFG abcdefg 1234567890 太多插件字体预览|r'
end

function FontPicker:FormatButton(button)
	button:SetCheckedTexture([[Interface\Buttons\UI-CheckBox-Check]])
    button:GetCheckedTexture():ClearAllPoints()
    button:GetCheckedTexture():SetPoint('LEFT')
    button:GetCheckedTexture():SetSize(26, 26)
end

function FontPicker:UpdateButton(button, item)
    button:GetFontString():SetFont(item, 14, 'OUTLINE')
end

function FontPicker:GetPositionArgs()
    return 160, -15, 0, 0
end

function FontPicker:GetWidgetType()
    return 'FontPicker'
end
