
local Widget = LIBTD('Widget')
if not Widget or Widget('Frame') then return end

local tinsert = tinsert
local CreateFrame = CreateFrame

local Frame = Widget:NewModule('Frame', CreateFrame('ScrollFrame'))
Widget:CopyFunctions(Frame, 'Into', 'IsWidgetType', 'CreateLabel')

function Frame:New(parent)
    local frame = self:Bind(CreateFrame('ScrollFrame', nil, parent))
    if not parent then return frame end
    
    frame.widgets = {}
    
    if parent and not parent.IsWidgetType then
        frame:SetScript('OnShow', self.Update)
    end
    
    return frame
end

function Frame:SetDB(db)
    for i, widget in ipairs(self.widgets) do
        widget:SetDB(db)
    end
end

function Frame:InsertKey(...)
    for i, widget in ipairs(self.widgets) do
        widget:InsertKey(...)
    end
end

function Frame:SetKeys(...)
    for i, widget in ipairs(self.widgets) do
        widget:SetKeys(...)
    end
end

function Frame:SetKey(key, index)
    for i, widget in ipairs(self.widgets) do
        widget:SetKey(key, index)
    end
end

function Frame:ClearKeys()
    for i, widget in ipairs(self.widgets) do
        widget:ClearKeys()
    end
end

function Frame:SetDBAndKeys(db, ...)
    for i, widget in ipairs(self.widgets) do
        widget:SetDBAndKeys(db, ...)
    end
end

function Frame:Update()
    for i, widget in ipairs(self.widgets) do
        widget:Update()
    end
end

function Frame:AddWidget(widget)
    tinsert(self.widgets, widget)
end

function Frame:IntoOption(name, parent)
    if not name then return end
    
    self.name, self.parent = name, parent
	InterfaceOptions_AddCategory(self)
end

function Frame:GetWidgetType()
    return 'Frame'
end
