
local Widget = LIBTD('Widget')
if not Widget or Widget('Slider') then return end

local CreateFrame = CreateFrame

local Slider = Widget:NewModule('Slider', CreateFrame('Slider'))

function Slider:New(parent, db, ...)
    local slider = self:Bind(CreateFrame('Slider', nil, parent))
    Widget:CopyFunctions(slider)
    
	slider:SetBackdrop{
		bgFile = [[Interface\Buttons\UI-SliderBar-Background]],
		edgeFile = [[Interface\Buttons\UI-SliderBar-Border]],
		edgeSize = 8, tileSize = 8, tile = true, 
		insets = {left = 3, right = 3, top = 6, bottom = 6}
	}
	slider:SetOrientation('HORIZONTAL')
	slider:SetHitRectInsets(0, 0, 0, 0)
	slider:SetThumbTexture([[Interface\Buttons\UI-SliderBar-Button-Horizontal]])
	slider:SetHeight(17)
    slider:SetValueStep(1)
    
    slider:SetScript('OnValueChanged', self.OnValueChanged)
    
    slider.tdLabel = slider:CreateLabel('BOTTOMLEFT', 'TOPLEFT', 0, 0)
    slider.tdText = slider:CreateLabel('BOTTOMRIGHT', 'TOPRIGHT', 0, 0, true)
    
    slider.ratio = 1
    slider:SetDBAndKeys(db, ...)
    
    return slider
end

function Slider:SetLabelText(text)
    self.tdLabel:SetText(text)
end

function Slider:SetText(text)
    self.tdText:SetText(text)
end

function Slider:Update()
    self:SetValue((self:GetDBValue() or 0) / self.ratio)
end

function Slider:GetPositionArgs()
    return 40, -15, 0, 0 -- height, y, lx, rx
end

function Slider:OnValueChanged(value)
    self:SetText(value * self.ratio)
    self:SaveDBValue(value * self.ratio)
end

function Slider:OnMouseWheel(y)
    self:SetValue(self:GetValue() - y)
end

function Slider:SetRatio(ratio)
    self.ratio = ratio
end

function Slider:GetWidgetType()
    return 'Slider'
end
